
/*  A Bison parser, made from d:/v/temp/pcb/src/parse_y.y with Bison version GNU Bison version 1.24
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	NUMBER	258
#define	CHAR_CONST	259
#define	FLOAT	260
#define	STRING	261
#define	T_FILEVERSION	262
#define	T_PCB	263
#define	T_LAYER	264
#define	T_VIA	265
#define	T_RAT	266
#define	T_LINE	267
#define	T_ARC	268
#define	T_RECTANGLE	269
#define	T_TEXT	270
#define	T_ELEMENTLINE	271
#define	T_ELEMENT	272
#define	T_PIN	273
#define	T_PAD	274
#define	T_GRID	275
#define	T_FLAGS	276
#define	T_SYMBOL	277
#define	T_SYMBOLLINE	278
#define	T_CURSOR	279
#define	T_ELEMENTARC	280
#define	T_MARK	281
#define	T_GROUPS	282
#define	T_STYLES	283
#define	T_POLYGON	284
#define	T_POLYGON_HOLE	285
#define	T_NETLIST	286
#define	T_NET	287
#define	T_CONN	288
#define	T_AREA	289
#define	T_THERMAL	290
#define	T_DRC	291
#define	T_ATTRIBUTE	292

#line 11 "d:/v/temp/pcb/src/parse_y.y"

/*
 *                            COPYRIGHT
 *
 *  PCB, interactive printed circuit board design
 *  Copyright (C) 1994,1995,1996 Thomas Nau
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Contact addresses for paper mail and Email:
 *  Thomas Nau, Schlehenweg 15, 88471 Baustetten, Germany
 *  Thomas.Nau@rz.uni-ulm.de
 *
 */

/* grammar to parse ASCII input of PCB description
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#define GRIDFIT(x,g) (int)(0.5 + (int)(((x)+(g)/2.)/(g))*(g))
#include "global.h"
#include "create.h"
#include "data.h"
#include "error.h"
#include "file.h"
#include "mymem.h"
#include "misc.h"
#include "parse_l.h"
#include "polygon.h"
#include "remove.h"
#include "rtree.h"
#include "strflags.h"
#include "thermal.h"

#ifdef HAVE_LIBDMALLOC
# include <dmalloc.h> /* see http://dmalloc.com */
#endif

RCSID("$Id$");

static	LayerTypePtr	Layer;
static	PolygonTypePtr	Polygon;
static	SymbolTypePtr	Symbol;
static	int		pin_num;
static	LibraryMenuTypePtr	Menu;
static	bool			LayerFlag[MAX_LAYER + 2];

extern	char			*yytext;		/* defined by LEX */
extern	PCBTypePtr		yyPCB;
extern	DataTypePtr		yyData;
extern	ElementTypePtr	yyElement;
extern	FontTypePtr		yyFont;
extern	int				yylineno;		/* linenumber */
extern	char			*yyfilename;	/* in this file */

static char *layer_group_string; 

static AttributeListTypePtr attr_list; 

int yyerror(const char *s);
int yylex();
static int check_file_version (int);


#line 91 "d:/v/temp/pcb/src/parse_y.y"
typedef union									/* define YYSTACK type */
{
	int		number;
	float		floating;
	char		*string;
	FlagType	flagtype;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		618
#define	YYFLAG		-32768
#define	YYNTBASE	42

#define YYTRANSLATE(x) ((unsigned)(x) <= 292 ? yytranslate[x] : 150)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    40,
    41,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    38,     2,    39,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     6,     8,     9,    24,    25,    28,    29,
    32,    34,    35,    36,    39,    40,    45,    50,    57,    64,
    66,    68,    70,    72,    79,    87,    95,   103,   110,   117,
   124,   125,   126,   131,   132,   137,   138,   140,   142,   144,
   151,   159,   169,   174,   179,   180,   185,   186,   191,   196,
   197,   199,   200,   202,   205,   207,   208,   211,   213,   215,
   216,   219,   221,   223,   225,   227,   229,   231,   243,   255,
   266,   276,   285,   296,   307,   308,   319,   321,   322,   324,
   327,   329,   331,   333,   335,   337,   339,   348,   350,   352,
   354,   355,   358,   360,   371,   382,   392,   405,   418,   430,
   439,   449,   459,   460,   470,   471,   473,   476,   477,   483,
   485,   488,   493,   498,   499,   501,   503,   505,   507,   509,
   510,   523,   524,   540,   541,   558,   559,   578,   579,   598,
   600,   603,   605,   607,   609,   611,   613,   622,   631,   642,
   653,   659,   665,   666,   669,   671,   674,   676,   678,   680,
   682,   691,   700,   711,   722,   723,   726,   739,   752,   763,
   773,   782,   796,   810,   822,   833,   835,   837,   839,   842,
   843,   853,   854,   864,   866,   868,   870,   873,   875,   877,
   878,   887,   896,   898,   899,   906,   908,   909,   911,   914,
   915,   925,   927,   928,   930,   933,   938,   940,   943,   949,
   951
};

static const short yyrhs[] = {    43,
     0,    46,     0,    49,     0,     1,     0,     0,    44,    51,
    52,    53,    58,    59,    60,    61,    65,    66,    67,    48,
    68,   138,     0,     0,    45,   102,     0,     0,    47,    68,
     0,    49,     0,     0,     0,    50,   129,     0,     0,     7,
    38,     3,    39,     0,     8,    40,     6,    41,     0,     8,
    40,     6,     3,     3,    41,     0,     8,    38,     6,     3,
     3,    39,     0,    54,     0,    55,     0,    56,     0,    57,
     0,    20,    40,     3,     3,     3,    41,     0,    20,    40,
     3,     3,     3,     3,    41,     0,    20,    40,     5,     3,
     3,     3,    41,     0,    20,    38,     5,     3,     3,     3,
    39,     0,    24,    40,     3,     3,     3,    41,     0,    24,
    38,     3,     3,     3,    39,     0,    24,    38,     3,     3,
     5,    39,     0,     0,     0,    34,    38,     5,    39,     0,
     0,    35,    38,     5,    39,     0,     0,    62,     0,    63,
     0,    64,     0,    36,    38,     3,     3,     3,    39,     0,
    36,    38,     3,     3,     3,     3,    39,     0,    36,    38,
     3,     3,     3,     3,     3,     3,    39,     0,    21,    40,
     3,    41,     0,    21,    40,     6,    41,     0,     0,    27,
    40,     6,    41,     0,     0,    28,    40,     6,    41,     0,
    28,    38,     6,    39,     0,     0,    69,     0,     0,    70,
     0,    69,    70,     0,    73,     0,     0,    71,   147,     0,
    79,     0,    80,     0,     0,    72,   102,     0,     1,     0,
    74,     0,    75,     0,    76,     0,    77,     0,    78,     0,
    10,    38,     3,     3,     3,     3,     3,     3,     6,   128,
    39,     0,    10,    40,     3,     3,     3,     3,     3,     3,
     6,     3,    41,     0,    10,    40,     3,     3,     3,     3,
     3,     6,     3,    41,     0,    10,    40,     3,     3,     3,
     3,     6,     3,    41,     0,    10,    40,     3,     3,     3,
     6,     3,    41,     0,    11,    38,     3,     3,     3,     3,
     3,     3,   128,    39,     0,    11,    40,     3,     3,     3,
     3,     3,     3,     3,    41,     0,     0,     9,    40,     3,
     6,   149,    41,    40,    81,    82,    41,     0,    83,     0,
     0,    84,     0,    83,    84,     0,    86,     0,    87,     0,
    88,     0,    89,     0,    90,     0,    91,     0,    14,    40,
     3,     3,     3,     3,     3,    41,     0,    94,     0,    93,
     0,    92,     0,     0,    85,   147,     0,    95,     0,    12,
    38,     3,     3,     3,     3,     3,     3,   128,    39,     0,
    12,    40,     3,     3,     3,     3,     3,     3,     3,    41,
     0,    12,    40,     3,     3,     3,     3,     3,     3,    41,
     0,    13,    38,     3,     3,     3,     3,     3,     3,     3,
     3,   128,    39,     0,    13,    40,     3,     3,     3,     3,
     3,     3,     3,     3,     3,    41,     0,    13,    40,     3,
     3,     3,     3,     3,     3,     3,     3,    41,     0,    15,
    40,     3,     3,     3,     6,     3,    41,     0,    15,    40,
     3,     3,     3,     3,     6,     3,    41,     0,    15,    38,
     3,     3,     3,     3,     6,   128,    39,     0,     0,    29,
    40,   128,    41,    40,    96,   100,    97,    41,     0,     0,
    98,     0,    97,    98,     0,     0,    30,    40,    99,   100,
    41,     0,   101,     0,   100,   101,     0,    40,     3,     3,
    41,     0,    38,     3,     3,    39,     0,     0,   103,     0,
   105,     0,   107,     0,   109,     0,   111,     0,     0,    17,
    40,     6,     6,     3,     3,     3,    41,    40,   104,   113,
    41,     0,     0,    17,    40,     3,     6,     6,     3,     3,
     3,     3,     3,    41,    40,   106,   113,    41,     0,     0,
    17,    40,     3,     6,     6,     6,     3,     3,     3,     3,
     3,    41,    40,   108,   113,    41,     0,     0,    17,    40,
     3,     6,     6,     6,     3,     3,     3,     3,     3,     3,
     3,    41,    40,   110,   116,    41,     0,     0,    17,    38,
   128,     6,     6,     6,     3,     3,     3,     3,     3,     3,
   128,    39,    40,   112,   116,    41,     0,   114,     0,   113,
   114,     0,   121,     0,   122,     0,   123,     0,   126,     0,
   127,     0,    16,    38,     3,     3,     3,     3,     3,    39,
     0,    16,    40,     3,     3,     3,     3,     3,    41,     0,
    25,    38,     3,     3,     3,     3,     3,     3,     3,    39,
     0,    25,    40,     3,     3,     3,     3,     3,     3,     3,
    41,     0,    26,    38,     3,     3,    39,     0,    26,    40,
     3,     3,    41,     0,     0,   115,   147,     0,   117,     0,
   116,   117,     0,   120,     0,   119,     0,   125,     0,   124,
     0,    16,    38,     3,     3,     3,     3,     3,    39,     0,
    16,    40,     3,     3,     3,     3,     3,    41,     0,    25,
    38,     3,     3,     3,     3,     3,     3,     3,    39,     0,
    25,    40,     3,     3,     3,     3,     3,     3,     3,    41,
     0,     0,   118,   147,     0,    18,    38,     3,     3,     3,
     3,     3,     3,     6,     6,   128,    39,     0,    18,    40,
     3,     3,     3,     3,     3,     3,     6,     6,     3,    41,
     0,    18,    40,     3,     3,     3,     3,     6,     6,     3,
    41,     0,    18,    40,     3,     3,     3,     3,     6,     3,
    41,     0,    18,    40,     3,     3,     3,     6,     3,    41,
     0,    19,    38,     3,     3,     3,     3,     3,     3,     3,
     6,     6,   128,    39,     0,    19,    40,     3,     3,     3,
     3,     3,     3,     3,     6,     6,     3,    41,     0,    19,
    40,     3,     3,     3,     3,     3,     6,     6,     3,    41,
     0,    19,    40,     3,     3,     3,     3,     3,     6,     3,
    41,     0,     3,     0,     6,     0,   130,     0,   129,   130,
     0,     0,    22,    38,   133,     3,    39,    40,   131,   134,
    41,     0,     0,    22,    40,   133,     3,    41,    40,   132,
   134,    41,     0,     3,     0,     4,     0,   135,     0,   134,
   135,     0,   136,     0,   137,     0,     0,    23,    40,     3,
     3,     3,     3,     3,    41,     0,    23,    38,     3,     3,
     3,     3,     3,    39,     0,   139,     0,     0,    31,    40,
    41,    40,   140,    41,     0,   141,     0,     0,   142,     0,
   141,   142,     0,     0,    32,    40,     6,     6,    41,    40,
   143,   144,    41,     0,   145,     0,     0,   146,     0,   145,
   146,     0,    33,    40,     6,    41,     0,   148,     0,   147,
   148,     0,    37,    40,     6,     6,    41,     0,     6,     0,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   114,   115,   116,   117,   141,   161,   195,   198,   206,   222,
   225,   226,   230,   245,   271,   271,   302,   308,   314,   343,
   344,   345,   346,   349,   357,   370,   382,   414,   420,   426,
   432,   449,   450,   475,   476,   508,   509,   510,   511,   515,
   525,   536,   563,   567,   571,   599,   603,   647,   655,   663,
   667,   668,   672,   673,   677,   678,   679,   679,   680,   681,
   689,   689,   693,   694,   695,   696,   697,   733,   742,   753,
   763,   773,   809,   814,   845,   865,   869,   870,   874,   875,
   879,   880,   881,   882,   883,   884,   886,   891,   892,   893,
   894,   895,   895,   925,   933,   942,   990,   998,  1007,  1044,
  1054,  1072,  1120,  1126,  1161,  1162,  1163,  1167,  1171,  1175,
  1176,  1181,  1185,  1189,  1246,  1247,  1248,  1249,  1250,  1257,
  1265,  1275,  1283,  1293,  1302,  1312,  1323,  1333,  1344,  1413,
  1414,  1418,  1419,  1420,  1421,  1422,  1424,  1429,  1434,  1439,
  1444,  1449,  1454,  1455,  1458,  1459,  1463,  1464,  1465,  1466,
  1468,  1474,  1481,  1486,  1491,  1492,  1532,  1544,  1556,  1567,
  1583,  1637,  1651,  1664,  1675,  1686,  1687,  1691,  1692,  1715,
  1731,  1732,  1748,  1752,  1753,  1757,  1758,  1762,  1763,  1764,
  1785,  1792,  1808,  1809,  1813,  1818,  1819,  1823,  1824,  1846,
  1852,  1856,  1857,  1861,  1862,  1881,  1910,  1911,  1914,  1922,
  1923
};

static const char * const yytname[] = {   "$","error","$undefined.","NUMBER",
"CHAR_CONST","FLOAT","STRING","T_FILEVERSION","T_PCB","T_LAYER","T_VIA","T_RAT",
"T_LINE","T_ARC","T_RECTANGLE","T_TEXT","T_ELEMENTLINE","T_ELEMENT","T_PIN",
"T_PAD","T_GRID","T_FLAGS","T_SYMBOL","T_SYMBOLLINE","T_CURSOR","T_ELEMENTARC",
"T_MARK","T_GROUPS","T_STYLES","T_POLYGON","T_POLYGON_HOLE","T_NETLIST","T_NET",
"T_CONN","T_AREA","T_THERMAL","T_DRC","T_ATTRIBUTE","'['","']'","'('","')'",
"parse","parsepcb","@1","@2","parsedata","@3","pcbfont","parsefont","@4","pcbfileversion",
"pcbname","pcbgrid","pcbgridold","pcbgridnew","pcb2grid","pcbhigrid","pcbcursor",
"polyarea","pcbthermal","pcbdrc","pcbdrc1","pcbdrc2","pcbdrc3","pcbflags","pcbgroups",
"pcbstyles","pcbdata","pcbdefinitions","pcbdefinition","@5","@6","via","via_hi_format",
"via_2.0_format","via_1.7_format","via_newformat","via_oldformat","rats","layer",
"@7","layerdata","layerdefinitions","layerdefinition","@8","line_hi_format",
"line_1.7_format","line_oldformat","arc_hi_format","arc_1.7_format","arc_oldformat",
"text_oldformat","text_newformat","text_hi_format","polygon_format","@9","polygonholes",
"polygonhole","@10","polygonpoints","polygonpoint","element","element_oldformat",
"@11","element_1.3.4_format","@12","element_newformat","@13","element_1.7_format",
"@14","element_hi_format","@15","elementdefinitions","elementdefinition","@16",
"relementdefs","relementdef","@17","pin_hi_format","pin_1.7_format","pin_1.6.3_format",
"pin_newformat","pin_oldformat","pad_hi_format","pad_1.7_format","pad_newformat",
"pad","flags","symbols","symbol","@18","@19","symbolid","symboldata","symboldefinitions",
"symboldefinition","hiressymbol","pcbnetlist","pcbnetdef","nets","netdefs","net",
"@20","connections","conndefs","conn","attributes","attribute","opt_string",
""
};
#endif

static const short yyr1[] = {     0,
    42,    42,    42,    42,    44,    43,    45,    43,    47,    46,
    48,    48,    50,    49,    51,    51,    52,    52,    52,    53,
    53,    53,    53,    54,    55,    56,    57,    58,    58,    58,
    58,    59,    59,    60,    60,    61,    61,    61,    61,    62,
    63,    64,    65,    65,    65,    66,    66,    67,    67,    67,
    68,    68,    69,    69,    70,    71,    70,    70,    70,    72,
    70,    70,    73,    73,    73,    73,    73,    74,    75,    76,
    77,    78,    79,    79,    81,    80,    82,    82,    83,    83,
    84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
    85,    84,    84,    86,    87,    88,    89,    90,    91,    92,
    93,    94,    96,    95,    97,    97,    97,    99,    98,   100,
   100,   101,   101,   101,   102,   102,   102,   102,   102,   104,
   103,   106,   105,   108,   107,   110,   109,   112,   111,   113,
   113,   114,   114,   114,   114,   114,   114,   114,   114,   114,
   114,   114,   115,   114,   116,   116,   117,   117,   117,   117,
   117,   117,   117,   117,   118,   117,   119,   120,   121,   122,
   123,   124,   125,   126,   127,   128,   128,   129,   129,   131,
   130,   132,   130,   133,   133,   134,   134,   135,   135,   135,
   136,   137,   138,   138,   139,   140,   140,   141,   141,   143,
   142,   144,   144,   145,   145,   146,   147,   147,   148,   149,
   149
};

static const short yyr2[] = {     0,
     1,     1,     1,     1,     0,    14,     0,     2,     0,     2,
     1,     0,     0,     2,     0,     4,     4,     6,     6,     1,
     1,     1,     1,     6,     7,     7,     7,     6,     6,     6,
     0,     0,     4,     0,     4,     0,     1,     1,     1,     6,
     7,     9,     4,     4,     0,     4,     0,     4,     4,     0,
     1,     0,     1,     2,     1,     0,     2,     1,     1,     0,
     2,     1,     1,     1,     1,     1,     1,    11,    11,    10,
     9,     8,    10,    10,     0,    10,     1,     0,     1,     2,
     1,     1,     1,     1,     1,     1,     8,     1,     1,     1,
     0,     2,     1,    10,    10,     9,    12,    12,    11,     8,
     9,     9,     0,     9,     0,     1,     2,     0,     5,     1,
     2,     4,     4,     0,     1,     1,     1,     1,     1,     0,
    12,     0,    15,     0,    16,     0,    18,     0,    18,     1,
     2,     1,     1,     1,     1,     1,     8,     8,    10,    10,
     5,     5,     0,     2,     1,     2,     1,     1,     1,     1,
     8,     8,    10,    10,     0,     2,    12,    12,    10,     9,
     8,    13,    13,    11,    10,     1,     1,     1,     2,     0,
     9,     0,     9,     1,     1,     1,     2,     1,     1,     0,
     8,     8,     1,     0,     6,     1,     0,     1,     2,     0,
     9,     1,     0,     1,     2,     4,     1,     2,     5,     1,
     0
};

static const short yydefact[] = {     0,
     4,     1,    15,     0,     2,     0,     3,     0,     0,     0,
     0,     8,   115,   116,   117,   118,   119,    62,     0,     0,
     0,    10,     0,    53,     0,     0,    55,    63,    64,    65,
    66,    67,    58,    59,     0,    14,   168,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    54,     0,    57,
   197,    61,     0,     0,   169,     0,     0,     0,     0,    31,
    20,    21,    22,    23,   166,   167,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   198,   174,   175,     0,     0,
    16,     0,     0,     0,     0,     0,    32,     0,     0,     0,
   201,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    17,     0,     0,     0,     0,     0,     0,    34,     0,     0,
     0,   200,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    36,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   199,   170,   172,    19,    18,     0,     0,     0,     0,     0,
     0,     0,     0,    45,    37,    38,    39,     0,     0,     0,
     0,    75,     0,     0,     0,     0,     0,     0,   180,   180,
     0,     0,    24,     0,     0,     0,     0,    33,     0,     0,
     0,    47,     0,     0,     0,     0,    78,     0,     0,     0,
     0,    72,     0,     0,     0,     0,   176,   178,   179,     0,
    27,    25,    26,    29,    30,    28,    35,     0,     0,     0,
    50,     0,     0,     0,   120,     0,     0,     0,     0,     0,
     0,    77,    79,     0,    81,    82,    83,    84,    85,    86,
    90,    89,    88,    93,     0,     0,     0,    71,     0,     0,
     0,     0,   171,   177,   173,     0,     0,     0,     0,     0,
    12,     0,     0,     0,   143,     0,     0,     0,     0,     0,
     0,     0,     0,    76,    80,    92,     0,     0,    70,    73,
    74,     0,     0,     0,    43,    44,     0,     0,     0,     0,
    11,     0,     0,     0,     0,     0,     0,     0,     0,   143,
   130,     0,   132,   133,   134,   135,   136,     0,     0,     0,
     0,     0,     0,     0,     0,    68,    69,     0,     0,     0,
    40,    46,     0,     0,   184,     0,   122,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   121,   131,   144,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    41,    49,    48,     0,     6,   183,     0,   143,     0,
   124,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   103,     0,     0,     0,
     0,     0,   143,     0,   143,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   114,     0,     0,    42,     0,   128,   123,   126,   143,
     0,     0,     0,     0,     0,     0,   141,   142,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   105,   110,
   182,   181,   187,   155,   155,   125,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    87,     0,     0,
   100,     0,     0,     0,     0,   106,   111,     0,     0,   186,
   188,     0,     0,     0,     0,   155,   145,     0,   148,   147,
   150,   149,   155,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    96,     0,     0,   102,   101,     0,     0,   108,
   104,   107,     0,   185,   189,     0,     0,     0,     0,     0,
     0,     0,     0,   129,   146,   156,   127,   137,   138,     0,
     0,   161,     0,     0,     0,    94,    95,     0,     0,   113,
   112,   114,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   160,     0,     0,     0,     0,     0,     0,     0,    99,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   159,   165,     0,   139,   140,    97,    98,   109,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   164,   190,     0,
     0,     0,     0,     0,     0,     0,     0,   193,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   192,   194,
   151,   152,     0,     0,     0,     0,     0,     0,     0,   191,
   195,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   153,   154,   196,     0,     0,     0,     0,   157,
   158,     0,     0,   162,   163,     0,     0,     0
};

static const short yydefgoto[] = {   616,
     2,     3,     4,     5,     6,   280,     7,     8,    10,    40,
    60,    61,    62,    63,    64,    87,   108,   130,   154,   155,
   156,   157,   182,   211,   251,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,   187,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
   232,   233,   234,   392,   445,   446,   512,   419,   420,    12,
    13,   255,    14,   349,    15,   375,    16,   425,    17,   424,
   290,   291,   292,   456,   457,   458,   459,   460,   293,   294,
   295,   461,   462,   296,   297,    67,    36,    37,   169,   170,
    79,   196,   197,   198,   199,   346,   347,   449,   450,   451,
   568,   578,   579,   580,    50,    51,   113
};

static const short yypact[] = {    12,
-32768,-32768,    50,    59,-32768,    16,-32768,    39,    51,    80,
   122,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    58,   125,
   126,-32768,    41,-32768,    68,    59,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   129,    39,-32768,   103,   130,    92,
    56,   105,   110,   127,   138,   156,   180,-32768,    82,    68,
-32768,-32768,    32,    32,-32768,    86,   123,   183,   134,   184,
-32768,-32768,-32768,-32768,-32768,-32768,   201,   203,   204,   205,
   209,   210,   211,   212,   213,-32768,-32768,-32768,   214,   215,
-32768,   217,     3,   148,   168,   137,   187,   218,   219,   220,
   221,   223,   225,   226,   227,   228,   192,   191,   230,   232,
-32768,   234,   235,   236,   237,   238,   206,   208,   239,   120,
   243,-32768,   207,   244,   133,   246,   247,   216,   222,   224,
   229,   231,   248,   249,   250,   251,   252,   253,   233,   240,
   256,   257,   258,   260,   241,   262,   139,   263,   264,   266,
-32768,-32768,-32768,-32768,-32768,   267,     4,   270,   173,   271,
   245,   272,   254,   261,-32768,-32768,-32768,   275,   276,   280,
   255,-32768,   282,   143,   283,   259,   284,   285,   268,   268,
   265,   269,-32768,   273,   274,   278,   277,-32768,   281,   286,
   279,   288,   287,   290,   291,   289,    54,   292,   293,   294,
   295,-32768,    56,   298,   141,    -9,-32768,-32768,-32768,    14,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   299,   144,   297,
   296,   300,   302,   303,-32768,   142,   146,   301,   147,   304,
   305,    54,-32768,    68,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    56,   306,   307,-32768,   308,   309,
   318,   319,-32768,-32768,-32768,   320,   310,   311,   321,   150,
   312,   322,   313,   323,    74,   325,   327,   328,   329,   330,
   332,   335,    56,-32768,-32768,    68,   314,   315,-32768,-32768,
-32768,   336,   337,    15,-32768,-32768,   316,   339,   343,    64,
-32768,   340,   324,     5,   153,   326,   331,   154,   157,    78,
-32768,    68,-32768,-32768,-32768,-32768,-32768,   352,   355,   356,
   357,   358,   359,   360,   333,-32768,-32768,   362,   364,    21,
-32768,-32768,   334,   338,   341,    56,-32768,   365,   342,   366,
   367,   372,   373,   374,   375,   377,   378,-32768,-32768,    68,
   380,   381,   382,   383,   384,   385,   386,   350,   388,   389,
   390,-32768,-32768,-32768,   354,-32768,-32768,   361,    74,   363,
-32768,   392,   393,   394,   395,   396,   398,   399,   400,   402,
   403,   405,   406,   407,   408,   145,-32768,   409,   410,   376,
   379,   387,    91,   391,    74,   411,   414,   415,   416,   418,
   419,   397,   401,   420,   421,   422,   423,   425,   424,   426,
   430,   158,   404,   412,-32768,   417,-32768,-32768,-32768,   102,
   431,   432,   149,   434,   435,   436,-32768,-32768,   437,   438,
   441,   442,   413,    56,   444,   427,   445,   446,     0,-32768,
-32768,-32768,   428,   119,   119,-32768,   447,   448,   449,   453,
   455,   456,   458,    56,     6,   459,   460,-32768,   433,   429,
-32768,   461,   462,   439,    -2,-32768,-32768,   440,   443,   428,
-32768,   161,   162,   165,   166,    61,-32768,    68,-32768,-32768,
-32768,-32768,   115,   450,   451,   151,   452,   463,   464,   468,
   457,   454,-32768,   470,   471,-32768,-32768,   465,   466,-32768,
-32768,-32768,   469,-32768,-32768,   473,   474,   475,   478,   479,
   480,   482,   483,-32768,-32768,    68,-32768,-32768,-32768,   467,
   484,-32768,   155,   485,   487,-32768,-32768,    56,     7,-32768,
-32768,   158,   488,   494,   495,   496,   497,   498,   499,   500,
   502,-32768,   472,   476,   503,   477,   481,   486,   489,-32768,
    44,   490,   506,   507,   508,   509,   511,   512,   515,   516,
-32768,-32768,   491,-32768,-32768,-32768,-32768,-32768,   493,   517,
   518,   520,   521,   523,   524,   525,   526,-32768,-32768,   531,
   532,   533,   534,   535,   536,   537,   538,   242,   504,   501,
   541,   542,   543,   544,   545,   546,   510,   513,   242,-32768,
-32768,-32768,   547,   549,   548,   553,   554,   555,   556,-32768,
-32768,   557,   558,   559,   560,   522,   519,   527,    56,   564,
   563,   565,-32768,-32768,-32768,   539,   529,    56,   569,-32768,
-32768,   540,   550,-32768,-32768,   552,   573,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    57,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   -24,-32768,   551,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,    73,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,  -138,-32768,  -201,  -416,   561,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -344,  -286,-32768,  -113,  -400,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,  -192,-32768,   562,-32768,-32768,
   505,   172,  -185,-32768,-32768,-32768,-32768,-32768,-32768,   -21,
-32768,-32768,-32768,  -127,  -222,   -50,-32768
};


#define	YYLAST		598


static const short yytable[] = {    76,
   239,   266,   447,   329,   373,   100,   172,   318,   472,   529,
   244,    -9,     1,   195,   244,   -52,    18,   310,    -5,    -5,
    -9,    -9,    -9,   341,    19,    20,    21,   444,    -7,   444,
   400,   243,   -60,   -13,    77,    78,   195,   417,   481,   418,
   -51,    18,   267,   101,   173,   319,   473,   530,    -9,    19,
    20,    21,   -56,   311,   245,   495,     9,   -60,    65,   342,
    35,    66,   495,   -52,    18,   216,   217,   218,   219,   330,
   305,   -51,    19,    20,    21,    11,   452,   -56,   453,   454,
   -60,   417,   220,   418,   548,   455,   329,    39,    38,   285,
   -91,   286,   287,   285,   -52,   286,   287,    43,   288,   289,
   -56,   494,   288,   289,    49,    56,   285,    68,   286,   287,
    69,    59,    70,   329,   447,   288,   289,   285,   328,   286,
   287,    75,   132,   348,    81,   133,   288,   289,    82,    71,
   452,   398,   453,   454,   452,   137,   453,   454,   138,   455,
    72,   164,   426,   455,   165,   189,   247,   390,   190,   248,
   391,   429,   102,   500,   430,   497,   501,   524,    73,    41,
   525,    42,    44,    46,    45,    47,    53,    57,    54,    58,
   103,    84,   104,    85,   105,   175,   106,   176,   241,   256,
   242,   257,    74,   258,   261,   259,   262,   278,    83,   279,
   320,   324,   321,   325,   326,   417,   327,   418,   486,   488,
   487,   489,   490,   492,   491,   493,    88,    86,    89,    90,
    91,    92,    93,    94,    95,    76,    97,    98,    96,    99,
   107,   439,   111,   109,   110,   114,   112,   115,   116,   117,
   119,   120,   121,   118,   122,   496,   123,   124,   125,   126,
   127,   471,   129,   128,   131,   134,   136,   135,   139,   140,
   146,   147,   148,   149,   150,   315,   141,   151,   158,   159,
   160,   142,   161,   143,   163,   166,   167,   144,   168,   171,
   152,   145,   174,   177,   577,   153,   179,   183,   184,    76,
   162,   181,   185,   178,   188,   191,   193,   194,   208,   212,
   195,   180,   213,   214,   265,   186,   237,   235,   236,   192,
   240,   246,   252,   201,   253,   254,   482,   281,   268,   202,
   531,   463,   204,   203,   210,   528,   205,   206,   209,   207,
   272,   273,   274,   250,   282,   284,   277,   298,   215,   299,
   300,   301,   302,   -13,   303,   238,   249,   304,   308,   309,
   260,   200,   316,   263,   313,   264,   270,   269,   314,   271,
   275,   276,   306,   283,   331,   307,   312,   332,   333,   334,
   335,   336,   337,   317,   339,   322,   340,   350,   352,   353,
   323,   345,   343,   338,   354,   355,   356,   357,   344,   358,
   359,   351,   360,   361,   362,   363,   364,   365,   366,   367,
   368,   369,   370,   371,   376,   377,   378,   379,   380,   372,
   381,   382,   383,   374,   384,   385,   606,   386,   387,   388,
   389,   393,   394,   401,   395,   612,   402,   403,   404,   396,
   405,   406,   409,   410,   411,   412,   397,   413,   485,   414,
   399,   415,   416,   427,   428,   407,   431,   432,   433,   434,
   435,   408,   421,   436,   437,    76,   440,   442,   443,   464,
   465,   591,   422,   438,   466,   467,   423,   468,   469,   448,
   470,   474,   475,   478,   479,     0,   504,   441,   503,   477,
   505,   476,   508,   509,   513,   514,   515,   516,   480,   483,
   517,   518,   519,   484,   520,   521,   523,   526,   498,   527,
     0,   499,   502,   532,   507,   506,   533,   534,   535,   536,
   537,   538,   539,   510,   540,   543,   511,   522,   550,   551,
   552,   553,   541,   554,   555,   544,   542,   556,   557,   560,
   561,   545,   562,   563,   546,   564,   565,   566,   567,   547,
   549,   558,   559,   569,   570,   571,   572,   573,   574,   575,
   576,   582,   581,   583,   584,   585,   586,   587,   588,   589,
   594,   617,   592,   590,   593,   595,   596,   597,    80,   604,
   603,   598,   599,   600,   601,   602,   607,   605,   608,   611,
   609,   613,   618,    48,     0,     0,     0,   610,   614,     0,
     0,     0,     0,     0,     0,     0,    52,     0,     0,     0,
   615,     0,     0,     0,     0,     0,     0,    55
};

static const short yycheck[] = {    50,
   193,   224,   419,   290,   349,     3,     3,     3,     3,     3,
   196,     0,     1,    23,   200,     0,     1,     3,     7,     8,
     9,    10,    11,     3,     9,    10,    11,    30,    17,    30,
   375,    41,    17,    22,     3,     4,    23,    38,    41,    40,
     0,     1,   235,    41,    41,    41,    41,    41,    37,     9,
    10,    11,    37,    39,    41,   456,     7,    17,     3,    39,
    22,     6,   463,     0,     1,    12,    13,    14,    15,   292,
   263,    31,     9,    10,    11,    17,    16,    37,    18,    19,
    17,    38,    29,    40,    41,    25,   373,     8,    38,    16,
    37,    18,    19,    16,    31,    18,    19,    40,    25,    26,
    37,    41,    25,    26,    37,     3,    16,     3,    18,    19,
     6,    20,     3,   400,   531,    25,    26,    16,    41,    18,
    19,    40,     3,   316,    39,     6,    25,    26,     6,     3,
    16,    41,    18,    19,    16,     3,    18,    19,     6,    25,
     3,     3,    41,    25,     6,     3,     3,     3,     6,     6,
     6,     3,     5,     3,     6,    41,     6,     3,     3,    38,
     6,    40,    38,    38,    40,    40,    38,    38,    40,    40,
     3,    38,     5,    40,    38,     3,    40,     5,    38,    38,
    40,    40,     3,    38,    38,    40,    40,    38,     6,    40,
    38,    38,    40,    40,    38,    38,    40,    40,    38,    38,
    40,    40,    38,    38,    40,    40,     6,    24,     6,     6,
     6,     3,     3,     3,     3,   266,     3,     3,     6,     3,
    34,   414,     3,     6,     6,     3,     6,     3,     3,     3,
    39,    41,     3,     6,     3,   458,     3,     3,     3,     3,
     3,   434,    35,    38,     6,     3,     3,    41,     3,     3,
     3,     3,     3,     3,     3,   280,    41,     5,     3,     3,
     3,    40,     3,    40,     3,     3,     3,    39,     3,     3,
    38,    41,     3,     3,    33,    36,     5,     3,     3,   330,
    40,    21,     3,    39,     3,     3,     3,     3,     3,     3,
    23,    38,     3,     3,   222,    41,     3,     6,     6,    41,
     3,     3,     3,    39,     3,     3,   445,   251,     3,    41,
   512,   425,    39,    41,    27,   508,    39,    41,    40,    39,
     3,     3,     3,    28,     3,     3,     6,     3,    40,     3,
     3,     3,     3,    22,     3,    41,    40,     3,     3,     3,
    40,   170,     3,    40,     6,    41,    39,    41,     6,    41,
    41,    41,    39,    41,     3,    41,    41,     3,     3,     3,
     3,     3,     3,    40,     3,    40,     3,     3,     3,     3,
    40,    31,    39,    41,     3,     3,     3,     3,    41,     3,
     3,    40,     3,     3,     3,     3,     3,     3,     3,    40,
     3,     3,     3,    40,     3,     3,     3,     3,     3,    39,
     3,     3,     3,    41,     3,     3,   599,     3,     3,     3,
     3,     3,     3,     3,    39,   608,     3,     3,     3,    41,
     3,     3,     3,     3,     3,     3,    40,     3,   450,     6,
    40,     6,     3,     3,     3,    39,     3,     3,     3,     3,
     3,    41,    39,     3,     3,   496,     3,     3,     3,     3,
     3,   579,    41,    41,     6,     3,    40,     3,     3,    32,
     3,     3,     3,     3,     3,    -1,     3,    41,     6,    41,
     3,    39,     3,     3,     6,     3,     3,     3,    40,    40,
     3,     3,     3,    41,     3,     3,     3,     3,    39,     3,
    -1,    41,    41,     6,    41,    39,     3,     3,     3,     3,
     3,     3,     3,    39,     3,     3,    41,    41,     3,     3,
     3,     3,    41,     3,     3,    39,    41,     3,     3,     3,
     3,    41,     3,     3,    39,     3,     3,     3,     3,    41,
    41,    41,    40,     3,     3,     3,     3,     3,     3,     3,
     3,    41,    39,     3,     3,     3,     3,     3,     3,    40,
     3,     0,     6,    41,     6,     3,     3,     3,    54,    41,
    39,     6,     6,     6,     6,     6,     3,    41,     6,    41,
     6,     3,     0,    23,    -1,    -1,    -1,    39,    39,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,
    41,    -1,    -1,    -1,    -1,    -1,    -1,    36
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 192 "bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#else
#define YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#endif

int
yyparse(YYPARSE_PARAM)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 4:
#line 117 "d:/v/temp/pcb/src/parse_y.y"
{ YYABORT; ;
    break;}
case 5:
#line 141 "d:/v/temp/pcb/src/parse_y.y"
{
					/* reset flags for 'used layers';
					 * init font and data pointers
					 */
				int	i;

				if (!yyPCB)
				{
					Message("illegal fileformat\n");
					YYABORT;
				}
				for (i = 0; i < MAX_LAYER + 2; i++)
					LayerFlag[i] = false;
				yyFont = &yyPCB->Font;
				yyData = yyPCB->Data;
				yyData->pcb = yyPCB;
				yyData->LayerN = 0;
				layer_group_string = NULL;
			;
    break;}
case 6:
#line 173 "d:/v/temp/pcb/src/parse_y.y"
{
			  int i, j;
			  PCBTypePtr pcb_save = PCB;

			  if (layer_group_string == NULL)
			    layer_group_string = Settings.Groups;
			  CreateNewPCBPost (yyPCB, 0);
			  if (ParseGroupString(layer_group_string, &yyPCB->LayerGroups, yyData->LayerN))
			    {
			      Message("illegal layer-group string\n");
			      YYABORT;
			    }
			/* initialize the polygon clipping now since
			 * we didn't know the layer grouping before.
			 */
			PCB = yyPCB;
			for (i = 0; i < yyData->LayerN+2; i++)
			  for (j = 0; j < yyData->Layer[i].PolygonN; j++)
			      InitClip (yyData, &yyData->Layer[i], &yyData->Layer[i].Polygon[j]);
			PCB = pcb_save;
			;
    break;}
case 7:
#line 195 "d:/v/temp/pcb/src/parse_y.y"
{ PreLoadElementPCB ();
		    layer_group_string = NULL; ;
    break;}
case 8:
#line 198 "d:/v/temp/pcb/src/parse_y.y"
{ LayerFlag[0] = true;
		    LayerFlag[1] = true;
		    yyData->LayerN = 2;
		    PostLoadElementPCB ();
		  ;
    break;}
case 9:
#line 206 "d:/v/temp/pcb/src/parse_y.y"
{
					/* reset flags for 'used layers';
					 * init font and data pointers
					 */
				int	i;

				if (!yyData || !yyFont)
				{
					Message("illegal fileformat\n");
					YYABORT;
				}
				for (i = 0; i < MAX_LAYER + 2; i++)
					LayerFlag[i] = false;
				yyData->LayerN = 0;
			;
    break;}
case 13:
#line 231 "d:/v/temp/pcb/src/parse_y.y"
{
					/* mark all symbols invalid */
				int	i;

				if (!yyFont)
				{
					Message("illegal fileformat\n");
					YYABORT;
				}
				yyFont->Valid = false;
				for (i = 0; i <= MAX_FONTPOSITION; i++)
					yyFont->Symbol[i].Valid = false;
			;
    break;}
case 14:
#line 245 "d:/v/temp/pcb/src/parse_y.y"
{
				yyFont->Valid = true;
		  		SetFontInfo(yyFont);
			;
    break;}
case 16:
#line 273 "d:/v/temp/pcb/src/parse_y.y"
{
  if (check_file_version (yyvsp[-1].number) != 0)
    {
      YYABORT;
    }
;
    break;}
case 17:
#line 303 "d:/v/temp/pcb/src/parse_y.y"
{
				yyPCB->Name = yyvsp[-1].string;
				yyPCB->MaxWidth = MAX_COORD;
				yyPCB->MaxHeight = MAX_COORD;
			;
    break;}
case 18:
#line 309 "d:/v/temp/pcb/src/parse_y.y"
{
				yyPCB->Name = yyvsp[-3].string;
				yyPCB->MaxWidth = yyvsp[-2].number*100;
				yyPCB->MaxHeight = yyvsp[-1].number*100;
			;
    break;}
case 19:
#line 315 "d:/v/temp/pcb/src/parse_y.y"
{
				yyPCB->Name = yyvsp[-3].string;
				yyPCB->MaxWidth = yyvsp[-2].number;
				yyPCB->MaxHeight = yyvsp[-1].number;
			;
    break;}
case 24:
#line 350 "d:/v/temp/pcb/src/parse_y.y"
{
				yyPCB->Grid = yyvsp[-3].number*100;
				yyPCB->GridOffsetX = yyvsp[-2].number*100;
				yyPCB->GridOffsetY = yyvsp[-1].number*100;
			;
    break;}
case 25:
#line 358 "d:/v/temp/pcb/src/parse_y.y"
{
				yyPCB->Grid = yyvsp[-4].number*100;
				yyPCB->GridOffsetX = yyvsp[-3].number*100;
				yyPCB->GridOffsetY = yyvsp[-2].number*100;
				if (yyvsp[-1].number)
					Settings.DrawGrid = true;
				else
					Settings.DrawGrid = false;
			;
    break;}
case 26:
#line 371 "d:/v/temp/pcb/src/parse_y.y"
{
				yyPCB->Grid = yyvsp[-4].floating*100;
				yyPCB->GridOffsetX = yyvsp[-3].number*100;
				yyPCB->GridOffsetY = yyvsp[-2].number*100;
				if (yyvsp[-1].number)
					Settings.DrawGrid = true;
				else
					Settings.DrawGrid = false;
			;
    break;}
case 27:
#line 383 "d:/v/temp/pcb/src/parse_y.y"
{
				yyPCB->Grid = yyvsp[-4].floating;
				yyPCB->GridOffsetX = yyvsp[-3].number;
				yyPCB->GridOffsetY = yyvsp[-2].number;
				if (yyvsp[-1].number)
					Settings.DrawGrid = true;
				else
					Settings.DrawGrid = false;
			;
    break;}
case 28:
#line 415 "d:/v/temp/pcb/src/parse_y.y"
{
				yyPCB->CursorX = yyvsp[-3].number*100;
				yyPCB->CursorY = yyvsp[-2].number*100;
				yyPCB->Zoom = yyvsp[-1].number*2;
			;
    break;}
case 29:
#line 421 "d:/v/temp/pcb/src/parse_y.y"
{
				yyPCB->CursorX = yyvsp[-3].number;
				yyPCB->CursorY = yyvsp[-2].number;
				yyPCB->Zoom = yyvsp[-1].number;
			;
    break;}
case 30:
#line 427 "d:/v/temp/pcb/src/parse_y.y"
{
				yyPCB->CursorX = yyvsp[-3].number;
				yyPCB->CursorY = yyvsp[-2].number;
				yyPCB->Zoom = yyvsp[-1].floating;
			;
    break;}
case 33:
#line 451 "d:/v/temp/pcb/src/parse_y.y"
{
				yyPCB->IsleArea = yyvsp[-1].floating;
			;
    break;}
case 35:
#line 477 "d:/v/temp/pcb/src/parse_y.y"
{
				yyPCB->ThermScale = yyvsp[-1].floating;
			;
    break;}
case 40:
#line 516 "d:/v/temp/pcb/src/parse_y.y"
{
				yyPCB->Bloat = yyvsp[-3].number;
				yyPCB->Shrink = yyvsp[-2].number;
				yyPCB->minWid = yyvsp[-1].number;
				yyPCB->minRing = yyvsp[-1].number;
			;
    break;}
case 41:
#line 526 "d:/v/temp/pcb/src/parse_y.y"
{
				yyPCB->Bloat = yyvsp[-4].number;
				yyPCB->Shrink = yyvsp[-3].number;
				yyPCB->minWid = yyvsp[-2].number;
				yyPCB->minSlk = yyvsp[-1].number;
				yyPCB->minRing = yyvsp[-2].number;
			;
    break;}
case 42:
#line 537 "d:/v/temp/pcb/src/parse_y.y"
{
				yyPCB->Bloat = yyvsp[-6].number;
				yyPCB->Shrink = yyvsp[-5].number;
				yyPCB->minWid = yyvsp[-4].number;
				yyPCB->minSlk = yyvsp[-3].number;
				yyPCB->minDrill = yyvsp[-2].number;
				yyPCB->minRing = yyvsp[-1].number;
			;
    break;}
case 43:
#line 564 "d:/v/temp/pcb/src/parse_y.y"
{
				yyPCB->Flags = MakeFlags (yyvsp[-1].number & PCB_FLAGS);
			;
    break;}
case 44:
#line 568 "d:/v/temp/pcb/src/parse_y.y"
{
			  yyPCB->Flags = string_to_pcbflags (yyvsp[-1].string, yyerror);
			;
    break;}
case 46:
#line 600 "d:/v/temp/pcb/src/parse_y.y"
{
			  layer_group_string = yyvsp[-1].string;
			;
    break;}
case 48:
#line 648 "d:/v/temp/pcb/src/parse_y.y"
{
				if (ParseRouteString(yyvsp[-1].string, &yyPCB->RouteStyle[0], 100))
				{
					Message("illegal route-style string\n");
					YYABORT;
				}
			;
    break;}
case 49:
#line 656 "d:/v/temp/pcb/src/parse_y.y"
{
				if (ParseRouteString(yyvsp[-1].string, &yyPCB->RouteStyle[0], 1))
				{
					Message("illegal route-style string\n");
					YYABORT;
				}
			;
    break;}
case 56:
#line 678 "d:/v/temp/pcb/src/parse_y.y"
{ attr_list = & yyPCB->Attributes; ;
    break;}
case 60:
#line 682 "d:/v/temp/pcb/src/parse_y.y"
{
					/* clear pointer to force memory allocation by 
					 * the appropriate subroutine
					 */
				yyElement = NULL;
			;
    break;}
case 62:
#line 689 "d:/v/temp/pcb/src/parse_y.y"
{ YYABORT; ;
    break;}
case 68:
#line 734 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewVia(yyData, yyvsp[-8].number, yyvsp[-7].number, yyvsp[-6].number, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].string, yyvsp[-1].flagtype);
				free (yyvsp[-2].string);
			;
    break;}
case 69:
#line 743 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewVia(yyData, yyvsp[-8].number*100, yyvsp[-7].number*100, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number*100, yyvsp[-2].string,
					OldFlags(yyvsp[-1].number));
				free (yyvsp[-2].string);
			;
    break;}
case 70:
#line 754 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewVia(yyData, yyvsp[-7].number*100, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100,
					     (yyvsp[-5].number + yyvsp[-4].number)*100, yyvsp[-3].number*100, yyvsp[-2].string, OldFlags(yyvsp[-1].number));
				free (yyvsp[-2].string);
			;
    break;}
case 71:
#line 764 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewVia(yyData, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100, 200*GROUNDPLANEFRAME,
					(yyvsp[-4].number + 2*MASKFRAME)*100,  yyvsp[-3].number*100, yyvsp[-2].string, OldFlags(yyvsp[-1].number));
				free (yyvsp[-2].string);
			;
    break;}
case 72:
#line 774 "d:/v/temp/pcb/src/parse_y.y"
{
				BDimension	hole = (yyvsp[-3].number *DEFAULT_DRILLINGHOLE);

					/* make sure that there's enough copper left */
				if (yyvsp[-3].number -hole < MIN_PINORVIACOPPER && 
					yyvsp[-3].number > MIN_PINORVIACOPPER)
					hole = yyvsp[-3].number -MIN_PINORVIACOPPER;

				CreateNewVia(yyData, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number*100, 200*GROUNDPLANEFRAME,
					(yyvsp[-3].number + 2*MASKFRAME)*100, hole, yyvsp[-2].string, OldFlags(yyvsp[-1].number));
				free (yyvsp[-2].string);
			;
    break;}
case 73:
#line 810 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewRat(yyData, yyvsp[-7].number, yyvsp[-6].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-5].number, yyvsp[-2].number,
					Settings.RatThickness, yyvsp[-1].flagtype);
			;
    break;}
case 74:
#line 815 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewRat(yyData, yyvsp[-7].number*100, yyvsp[-6].number*100, yyvsp[-4].number*100, yyvsp[-3].number*100, yyvsp[-5].number, yyvsp[-2].number,
					Settings.RatThickness, OldFlags(yyvsp[-1].number));
			;
    break;}
case 75:
#line 846 "d:/v/temp/pcb/src/parse_y.y"
{
				if (yyvsp[-4].number <= 0 || yyvsp[-4].number > MAX_LAYER + 2)
				{
					yyerror("Layernumber out of range");
					YYABORT;
				}
				if (LayerFlag[yyvsp[-4].number-1])
				{
					yyerror("Layernumber used twice");
					YYABORT;
				}
				Layer = &yyData->Layer[yyvsp[-4].number-1];

					/* memory for name is already allocated */
				Layer->Name = yyvsp[-3].string;
				LayerFlag[yyvsp[-4].number-1] = true;
				if (yyData->LayerN + 2 < yyvsp[-4].number)
				  yyData->LayerN = yyvsp[-4].number - 2;
			;
    break;}
case 87:
#line 887 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewPolygonFromRectangle(Layer,
					yyvsp[-5].number*100, yyvsp[-4].number*100, (yyvsp[-5].number+yyvsp[-3].number)*100, (yyvsp[-4].number+yyvsp[-2].number)*100, OldFlags(yyvsp[-1].number));
			;
    break;}
case 91:
#line 894 "d:/v/temp/pcb/src/parse_y.y"
{ attr_list = & Layer->Attributes; ;
    break;}
case 94:
#line 926 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewLineOnLayer(Layer, yyvsp[-7].number, yyvsp[-6].number, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].number, yyvsp[-1].flagtype);
			;
    break;}
case 95:
#line 934 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewLineOnLayer(Layer, yyvsp[-7].number*100, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100,
						     yyvsp[-3].number*100, yyvsp[-2].number*100, OldFlags(yyvsp[-1].number));
			;
    break;}
case 96:
#line 943 "d:/v/temp/pcb/src/parse_y.y"
{
				/* eliminate old-style rat-lines */
			if ((yyvsp[-1].number & RATFLAG) == 0)
				CreateNewLineOnLayer(Layer, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number*100, yyvsp[-2].number*100,
					200*GROUNDPLANEFRAME, OldFlags(yyvsp[-1].number));
			;
    break;}
case 97:
#line 991 "d:/v/temp/pcb/src/parse_y.y"
{
			  CreateNewArcOnLayer(Layer, yyvsp[-9].number, yyvsp[-8].number, yyvsp[-7].number, yyvsp[-6].number, yyvsp[-3].number, yyvsp[-2].number, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-1].flagtype);
			;
    break;}
case 98:
#line 999 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewArcOnLayer(Layer, yyvsp[-9].number*100, yyvsp[-8].number*100, yyvsp[-7].number*100, yyvsp[-6].number*100, yyvsp[-3].number, yyvsp[-2].number,
						    yyvsp[-5].number*100, yyvsp[-4].number*100, OldFlags(yyvsp[-1].number));
			;
    break;}
case 99:
#line 1008 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewArcOnLayer(Layer, yyvsp[-8].number*100, yyvsp[-7].number*100, yyvsp[-6].number*100, yyvsp[-6].number*100, yyvsp[-3].number, yyvsp[-2].number,
					yyvsp[-4].number*100, 200*GROUNDPLANEFRAME, OldFlags(yyvsp[-1].number));
			;
    break;}
case 100:
#line 1045 "d:/v/temp/pcb/src/parse_y.y"
{
					/* use a default scale of 100% */
				CreateNewText(Layer,yyFont,yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number, 100, yyvsp[-2].string, OldFlags(yyvsp[-1].number));
				free (yyvsp[-2].string);
			;
    break;}
case 101:
#line 1055 "d:/v/temp/pcb/src/parse_y.y"
{
				if (yyvsp[-1].number & ONSILKFLAG)
				{
					LayerTypePtr lay = &yyData->Layer[yyData->LayerN +
						((yyvsp[-1].number & ONSOLDERFLAG) ? SOLDER_LAYER : COMPONENT_LAYER)];

					CreateNewText(lay ,yyFont, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].string,
						      OldFlags(yyvsp[-1].number));
				}
				else
					CreateNewText(Layer, yyFont, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].string,
						      OldFlags(yyvsp[-1].number));
				free (yyvsp[-2].string);
			;
    break;}
case 102:
#line 1073 "d:/v/temp/pcb/src/parse_y.y"
{
				/* FIXME: shouldn't know about .f */
				/* I don't think this matters because anything with hi_format
				 * will have the silk on its own layer in the file rather
				 * than using the ONSILKFLAG and having it in a copper layer.
				 * Thus there is no need for anything besides the 'else'
				 * part of this code.
				 */
				if (yyvsp[-1].flagtype.f & ONSILKFLAG)
				{
					LayerTypePtr lay = &yyData->Layer[yyData->LayerN +
						((yyvsp[-1].flagtype.f & ONSOLDERFLAG) ? SOLDER_LAYER : COMPONENT_LAYER)];

					CreateNewText(lay, yyFont, yyvsp[-6].number, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].string, yyvsp[-1].flagtype);
				}
				else
					CreateNewText(Layer, yyFont, yyvsp[-6].number, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].string, yyvsp[-1].flagtype);
				free (yyvsp[-2].string);
			;
    break;}
case 103:
#line 1122 "d:/v/temp/pcb/src/parse_y.y"
{
				Polygon = CreateNewPolygon(Layer, yyvsp[-2].flagtype);
			;
    break;}
case 104:
#line 1127 "d:/v/temp/pcb/src/parse_y.y"
{
				Cardinal contour, contour_start, contour_end;
				bool bad_contour_found = false;
				/* ignore junk */
				for (contour = 0; contour <= Polygon->HoleIndexN; contour++)
				  {
				    contour_start = (contour == 0) ?
						      0 : Polygon->HoleIndex[contour - 1];
				    contour_end = (contour == Polygon->HoleIndexN) ?
						 Polygon->PointN :
						 Polygon->HoleIndex[contour];
				    if (contour_end - contour_start < 3)
				      bad_contour_found = true;
				  }

				if (bad_contour_found)
				  {
				    Message("WARNING parsing file '%s'\n"
					    "    line:        %i\n"
					    "    description: 'ignored polygon (< 3 points in a contour)'\n",
					    yyfilename, yylineno);
				    DestroyObject(yyData, POLYGON_TYPE, Layer, Polygon, Polygon);
				  }
				else
				  {
				    SetPolygonBoundingBox (Polygon);
				    if (!Layer->polygon_tree)
				      Layer->polygon_tree = r_create_tree (NULL, 0, 0);
				    r_insert_entry (Layer->polygon_tree, (BoxType *) Polygon, 0);
				  }
			;
    break;}
case 108:
#line 1168 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewHoleInPolygon (Polygon);
			;
    break;}
case 112:
#line 1182 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewPointInPolygon(Polygon, yyvsp[-2].number*100, yyvsp[-1].number*100);
			;
    break;}
case 113:
#line 1186 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewPointInPolygon(Polygon, yyvsp[-2].number, yyvsp[-1].number);
			;
    break;}
case 120:
#line 1258 "d:/v/temp/pcb/src/parse_y.y"
{
				yyElement = CreateNewElement(yyData, yyElement, yyFont, NoFlags(),
					yyvsp[-6].string, yyvsp[-5].string, NULL, yyvsp[-4].number*100, yyvsp[-3].number*100, yyvsp[-2].number, 100, NoFlags(), false);
				free (yyvsp[-6].string);
				free (yyvsp[-5].string);
				pin_num = 1;
			;
    break;}
case 121:
#line 1266 "d:/v/temp/pcb/src/parse_y.y"
{
				SetElementBoundingBox(yyData, yyElement, yyFont);
			;
    break;}
case 122:
#line 1276 "d:/v/temp/pcb/src/parse_y.y"
{
				yyElement = CreateNewElement(yyData, yyElement, yyFont, OldFlags(yyvsp[-9].number),
					yyvsp[-8].string, yyvsp[-7].string, NULL, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number, yyvsp[-3].number, OldFlags(yyvsp[-2].number), false);
				free (yyvsp[-8].string);
				free (yyvsp[-7].string);
				pin_num = 1;
			;
    break;}
case 123:
#line 1284 "d:/v/temp/pcb/src/parse_y.y"
{
				SetElementBoundingBox(yyData, yyElement, yyFont);
			;
    break;}
case 124:
#line 1294 "d:/v/temp/pcb/src/parse_y.y"
{
				yyElement = CreateNewElement(yyData, yyElement, yyFont, OldFlags(yyvsp[-10].number),
					yyvsp[-9].string, yyvsp[-8].string, yyvsp[-7].string, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number, yyvsp[-3].number, OldFlags(yyvsp[-2].number), false);
				free (yyvsp[-9].string);
				free (yyvsp[-8].string);
				free (yyvsp[-7].string);
				pin_num = 1;
			;
    break;}
case 125:
#line 1303 "d:/v/temp/pcb/src/parse_y.y"
{
				SetElementBoundingBox(yyData, yyElement, yyFont);
			;
    break;}
case 126:
#line 1314 "d:/v/temp/pcb/src/parse_y.y"
{
				yyElement = CreateNewElement(yyData, yyElement, yyFont, OldFlags(yyvsp[-12].number),
					yyvsp[-11].string, yyvsp[-10].string, yyvsp[-9].string, (yyvsp[-8].number+yyvsp[-6].number)*100, (yyvsp[-7].number+yyvsp[-5].number)*100, yyvsp[-4].number, yyvsp[-3].number, OldFlags(yyvsp[-2].number), false);
				yyElement->MarkX = yyvsp[-8].number*100;
				yyElement->MarkY = yyvsp[-7].number*100;
				free (yyvsp[-11].string);
				free (yyvsp[-10].string);
				free (yyvsp[-9].string);
			;
    break;}
case 127:
#line 1324 "d:/v/temp/pcb/src/parse_y.y"
{
				SetElementBoundingBox(yyData, yyElement, yyFont);
			;
    break;}
case 128:
#line 1335 "d:/v/temp/pcb/src/parse_y.y"
{
				yyElement = CreateNewElement(yyData, yyElement, yyFont, yyvsp[-12].flagtype,
					yyvsp[-11].string, yyvsp[-10].string, yyvsp[-9].string, (yyvsp[-8].number+yyvsp[-6].number), (yyvsp[-7].number+yyvsp[-5].number), yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].flagtype, false);
				yyElement->MarkX = yyvsp[-8].number;
				yyElement->MarkY = yyvsp[-7].number;
				free (yyvsp[-11].string);
				free (yyvsp[-10].string);
				free (yyvsp[-9].string);
			;
    break;}
case 129:
#line 1345 "d:/v/temp/pcb/src/parse_y.y"
{
				SetElementBoundingBox(yyData, yyElement, yyFont);
			;
    break;}
case 137:
#line 1425 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewLineInElement(yyElement, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].number, yyvsp[-1].number);
			;
    break;}
case 138:
#line 1430 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewLineInElement(yyElement, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number*100, yyvsp[-2].number*100, yyvsp[-1].number*100);
			;
    break;}
case 139:
#line 1435 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewArcInElement(yyElement, yyvsp[-7].number, yyvsp[-6].number, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].number, yyvsp[-1].number);
			;
    break;}
case 140:
#line 1440 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewArcInElement(yyElement, yyvsp[-7].number*100, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number, yyvsp[-2].number, yyvsp[-1].number*100);
			;
    break;}
case 141:
#line 1445 "d:/v/temp/pcb/src/parse_y.y"
{
				yyElement->MarkX = yyvsp[-2].number;
				yyElement->MarkY = yyvsp[-1].number;
			;
    break;}
case 142:
#line 1450 "d:/v/temp/pcb/src/parse_y.y"
{
				yyElement->MarkX = yyvsp[-2].number*100;
				yyElement->MarkY = yyvsp[-1].number*100;
			;
    break;}
case 143:
#line 1454 "d:/v/temp/pcb/src/parse_y.y"
{ attr_list = & yyElement->Attributes; ;
    break;}
case 151:
#line 1469 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewLineInElement(yyElement, yyvsp[-5].number + yyElement->MarkX,
					yyvsp[-4].number + yyElement->MarkY, yyvsp[-3].number + yyElement->MarkX,
					yyvsp[-2].number + yyElement->MarkY, yyvsp[-1].number);
			;
    break;}
case 152:
#line 1475 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewLineInElement(yyElement, yyvsp[-5].number*100 + yyElement->MarkX,
					yyvsp[-4].number*100 + yyElement->MarkY, yyvsp[-3].number*100 + yyElement->MarkX,
					yyvsp[-2].number*100 + yyElement->MarkY, yyvsp[-1].number*100);
			;
    break;}
case 153:
#line 1482 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewArcInElement(yyElement, yyvsp[-7].number + yyElement->MarkX,
					yyvsp[-6].number + yyElement->MarkY, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].number, yyvsp[-1].number);
			;
    break;}
case 154:
#line 1487 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewArcInElement(yyElement, yyvsp[-7].number*100 + yyElement->MarkX,
					yyvsp[-6].number*100 + yyElement->MarkY, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number, yyvsp[-2].number, yyvsp[-1].number*100);
			;
    break;}
case 155:
#line 1491 "d:/v/temp/pcb/src/parse_y.y"
{ attr_list = & yyElement->Attributes; ;
    break;}
case 157:
#line 1533 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewPin(yyElement, yyvsp[-9].number + yyElement->MarkX,
					yyvsp[-8].number + yyElement->MarkY, yyvsp[-7].number, yyvsp[-6].number, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].string,
					yyvsp[-2].string, yyvsp[-1].flagtype);
				free (yyvsp[-3].string);
				free (yyvsp[-2].string);
			;
    break;}
case 158:
#line 1545 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewPin(yyElement, yyvsp[-9].number*100 + yyElement->MarkX,
					yyvsp[-8].number*100 + yyElement->MarkY, yyvsp[-7].number*100, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].string,
					yyvsp[-2].string, OldFlags(yyvsp[-1].number));
				free (yyvsp[-3].string);
				free (yyvsp[-2].string);
			;
    break;}
case 159:
#line 1557 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewPin(yyElement, yyvsp[-7].number*100, yyvsp[-6].number*100, yyvsp[-5].number*100, 200*GROUNDPLANEFRAME,
					(yyvsp[-5].number + 2*MASKFRAME)*100, yyvsp[-4].number*100, yyvsp[-3].string, yyvsp[-2].string, OldFlags(yyvsp[-1].number));
				free (yyvsp[-3].string);
				free (yyvsp[-2].string);
			;
    break;}
case 160:
#line 1568 "d:/v/temp/pcb/src/parse_y.y"
{
				char	p_number[8];

				sprintf(p_number, "%d", pin_num++);
				CreateNewPin(yyElement, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100, 200*GROUNDPLANEFRAME,
					(yyvsp[-4].number + 2*MASKFRAME)*100, yyvsp[-3].number*100, yyvsp[-2].string, p_number, OldFlags(yyvsp[-1].number));

				free (yyvsp[-2].string);
			;
    break;}
case 161:
#line 1584 "d:/v/temp/pcb/src/parse_y.y"
{
				BDimension	hole = (yyvsp[-3].number *DEFAULT_DRILLINGHOLE);
				char		p_number[8];

					/* make sure that there's enough copper left */
				if (yyvsp[-3].number -hole < MIN_PINORVIACOPPER && 
					yyvsp[-3].number > MIN_PINORVIACOPPER)
					hole = yyvsp[-3].number -MIN_PINORVIACOPPER;

				sprintf(p_number, "%d", pin_num++);
				CreateNewPin(yyElement, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number*100, 200*GROUNDPLANEFRAME,
					(yyvsp[-3].number + 2*MASKFRAME)*100, hole, yyvsp[-2].string, p_number, OldFlags(yyvsp[-1].number));
				free (yyvsp[-2].string);
			;
    break;}
case 162:
#line 1638 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewPad(yyElement, yyvsp[-10].number + yyElement->MarkX,
					yyvsp[-9].number + yyElement->MarkY,
					yyvsp[-8].number + yyElement->MarkX,
					yyvsp[-7].number + yyElement->MarkY, yyvsp[-6].number, yyvsp[-5].number, yyvsp[-4].number,
					yyvsp[-3].string, yyvsp[-2].string, yyvsp[-1].flagtype);
				free (yyvsp[-3].string);
				free (yyvsp[-2].string);
			;
    break;}
case 163:
#line 1652 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewPad(yyElement,yyvsp[-10].number*100 + yyElement->MarkX,
					yyvsp[-9].number*100 + yyElement->MarkY, yyvsp[-8].number*100 + yyElement->MarkX,
					yyvsp[-7].number*100 + yyElement->MarkY, yyvsp[-6].number*100, yyvsp[-5].number*100, yyvsp[-4].number*100,
					yyvsp[-3].string, yyvsp[-2].string, OldFlags(yyvsp[-1].number));
				free (yyvsp[-3].string);
				free (yyvsp[-2].string);
			;
    break;}
case 164:
#line 1665 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewPad(yyElement,yyvsp[-8].number*100,yyvsp[-7].number*100,yyvsp[-6].number*100,yyvsp[-5].number*100,yyvsp[-4].number*100, 200*GROUNDPLANEFRAME,
					(yyvsp[-4].number + 2*MASKFRAME)*100, yyvsp[-3].string,yyvsp[-2].string, OldFlags(yyvsp[-1].number));
				free (yyvsp[-3].string);
				free (yyvsp[-2].string);
			;
    break;}
case 165:
#line 1676 "d:/v/temp/pcb/src/parse_y.y"
{
				char		p_number[8];

				sprintf(p_number, "%d", pin_num++);
				CreateNewPad(yyElement,yyvsp[-7].number*100,yyvsp[-6].number*100,yyvsp[-5].number*100,yyvsp[-4].number*100,yyvsp[-3].number*100, 200*GROUNDPLANEFRAME,
					(yyvsp[-3].number + 2*MASKFRAME)*100, yyvsp[-2].string,p_number, OldFlags(yyvsp[-1].number));
				free (yyvsp[-2].string);
			;
    break;}
case 166:
#line 1686 "d:/v/temp/pcb/src/parse_y.y"
{ yyval.flagtype = OldFlags(yyvsp[0].number); ;
    break;}
case 167:
#line 1687 "d:/v/temp/pcb/src/parse_y.y"
{ yyval.flagtype = string_to_flags (yyvsp[0].string, yyerror); ;
    break;}
case 170:
#line 1716 "d:/v/temp/pcb/src/parse_y.y"
{
				if (yyvsp[-3].number <= 0 || yyvsp[-3].number > MAX_FONTPOSITION)
				{
					yyerror("fontposition out of range");
					YYABORT;
				}
				Symbol = &yyFont->Symbol[yyvsp[-3].number];
				if (Symbol->Valid)
				{
					yyerror("symbol ID used twice");
					YYABORT;
				}
				Symbol->Valid = true;
				Symbol->Delta = yyvsp[-2].number;
			;
    break;}
case 172:
#line 1733 "d:/v/temp/pcb/src/parse_y.y"
{
				if (yyvsp[-3].number <= 0 || yyvsp[-3].number > MAX_FONTPOSITION)
				{
					yyerror("fontposition out of range");
					YYABORT;
				}
				Symbol = &yyFont->Symbol[yyvsp[-3].number];
				if (Symbol->Valid)
				{
					yyerror("symbol ID used twice");
					YYABORT;
				}
				Symbol->Valid = true;
				Symbol->Delta = yyvsp[-2].number*100;
			;
    break;}
case 181:
#line 1786 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewLineInSymbol(Symbol, yyvsp[-5].number*100, yyvsp[-4].number*100, yyvsp[-3].number*100, yyvsp[-2].number*100, yyvsp[-1].number*100);
			;
    break;}
case 182:
#line 1793 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewLineInSymbol(Symbol, yyvsp[-5].number, yyvsp[-4].number, yyvsp[-3].number, yyvsp[-2].number, yyvsp[-1].number);
			;
    break;}
case 190:
#line 1847 "d:/v/temp/pcb/src/parse_y.y"
{
				Menu = CreateNewNet(&yyPCB->NetlistLib, yyvsp[-3].string, yyvsp[-2].string);
				free (yyvsp[-3].string);
				free (yyvsp[-2].string);
			;
    break;}
case 196:
#line 1882 "d:/v/temp/pcb/src/parse_y.y"
{
				CreateNewConnection(Menu, yyvsp[-1].string);
				free (yyvsp[-1].string);
			;
    break;}
case 199:
#line 1915 "d:/v/temp/pcb/src/parse_y.y"
{
			  CreateNewAttribute (attr_list, yyvsp[-2].string, yyvsp[-1].string ? yyvsp[-1].string : (char *)"");
				free (yyvsp[-2].string);
				free (yyvsp[-1].string);
			;
    break;}
case 200:
#line 1922 "d:/v/temp/pcb/src/parse_y.y"
{ yyval.string = yyvsp[0].string; ;
    break;}
case 201:
#line 1923 "d:/v/temp/pcb/src/parse_y.y"
{ yyval.string = 0; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 487 "bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 1926 "d:/v/temp/pcb/src/parse_y.y"


/* ---------------------------------------------------------------------------
 * error routine called by parser library
 */
int yyerror(const char * s)
{
	Message("ERROR parsing file '%s'\n"
		"    line:        %i\n"
		"    description: '%s'\n",
		yyfilename, yylineno, s);
	return(0);
}

int yywrap()
{
  return 1;
}


static int
check_file_version (int ver)
{
  if ( ver > PCB_FILE_VERSION ) {
    Message ("ERROR:  The file you are attempting to load is in a format\n"
	     "which is too new for this version of pcb.  To load this file\n"
	     "you need a version of pcb which is >= %d.  If you are\n"
	     "using a version built from git source, the source date\n"
	     "must be >= %d.  This copy of pcb can only read files\n"
	     "up to file version %d.\n", ver, ver, PCB_FILE_VERSION);
    return 1;
  }
  
  return 0;
}

